#include "ACriticalSectionObject.hpp"

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 April 2000 08:21:00

/* static */ unsigned long ACriticalSectionObject::referenceCounter = 0;


// Definition and creation in 1
static struct ACriticalSection
{
   ACriticalSection();
   ~ACriticalSection();
   static CRITICAL_SECTION*                     critical_Section;
} criticalSection;

ACriticalSection::ACriticalSection()
{
}

ACriticalSection::~ACriticalSection()
{
}

/* static */ CRITICAL_SECTION* ACriticalSection::critical_Section = 0;



// public
// Constructors
ACriticalSectionObject::ACriticalSectionObject()
{
   if(!criticalSection.critical_Section)
   {
     criticalSection.critical_Section = new CRITICAL_SECTION; // How about a memory leak? No delete found.
     InitializeCriticalSection(criticalSection.critical_Section);
   }
   EnterCriticalSection(criticalSection.critical_Section);
   ++referenceCounter;
}

// Destructor
ACriticalSectionObject::~ACriticalSectionObject()
{
   LeaveCriticalSection(criticalSection.critical_Section);
   --referenceCounter;
}

// Operators

// Accessors

// Mutators

// Operations
/* static */ unsigned long ACriticalSectionObject::count()
{
   return referenceCounter;
}

// protected
// Operations

// private
// Operations
ACriticalSectionObject::ACriticalSectionObject( const ACriticalSectionObject& aACriticalSectionObject)
{
}

ACriticalSectionObject& ACriticalSectionObject::operator=(const ACriticalSectionObject& aACriticalSectionObject)
{
   return *this;
}
