#ifndef _ACriticalSectionObject_hpp_
#define _ACriticalSectionObject_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 20:17:28
// Purpose: Lock a resource. Please take care that you will not call any function you
//          have not written yourself or you have the source code of as it can easily
//          lock your program.
//          Do not use any ATrace statements for debugging this class as it is used
//          by the ATrace class implementation.
//          On creation of an object of this class a critical section is entered. When
//          the object is deleted or goes out of scope the critical section is left.
//          TODO: Hide the new and delete operator so no object can be allocated on the heap?

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers
#ifdef __ALIBWINDOWS__
#include <windows.h>
#endif // __ALIBWINDOWS__

// STL headers

// Other class headers

// Forward declarations

class ALIBIMPEXP ACriticalSectionObject
{
   public:
      // Constructors
      ACriticalSectionObject();

      // Destructor
      virtual ~ACriticalSectionObject();

      // Operators

      // Accessors

      // Mutators

      // Operations
      static unsigned long                      count();

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations
      ACriticalSectionObject( const ACriticalSectionObject& aACriticalSectionObject);
      ACriticalSectionObject& operator=(const ACriticalSectionObject& aACriticalSectionObject);

      // Attributes
      static unsigned long                      referenceCounter;
}; // End of class declaration of ACriticalSectionObject
#endif //_ACriticalSectionObject_hpp_