#include "AHandle.hpp"

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@Askesis.nl

// Author : Joost Kraaijeveld
// Created: 19 Jan 1998 08:06:27

// public
// Constructors
AHandle::AHandle( void* aValue)
   : value(aValue)
{
}

AHandle::AHandle(const AHandle& aAHandle)
   : value(aAHandle.value)
{
   if (this != &aAHandle)
   {
   }
}

// Destructor
AHandle::~AHandle()
{
}

// Operators
AHandle& AHandle::operator=(const AHandle& aAHandle)
{
   if (this != &aAHandle)
   {
      // Call Base::operator=(aAHandle) for the base classes [in order of inheritence]
      value = aAHandle.value;
   }
   return *this;
}

bool AHandle::operator==(const AHandle& aAHandle) const
{
   return value == aAHandle.value;
}

bool AHandle::operator<(const AHandle& aAHandle) const
{
   return value < aAHandle.value;
}

AHandle::operator void*() const
{
   return value;
}

AHandle::operator void*()
{
   return (void*)value;
}

AHandle::operator void**() const
{
   return (void**)&value;
}

AHandle::operator void**()
{
   return (void**)&value;
}

// ALibObject functions
const char* AHandle::asChar() const
{
   static char handleString[11];
   sprintf(&handleString[0],"%#.10lx",(unsigned long)value);
   return &handleString[0];
}

const char* AHandle::asDebugChar() const
{
   static char handleString[11];
   sprintf(&handleString[0],"%#.10lx",(unsigned long)value);
   return &handleString[0];
}

unsigned long AHandle::asUnsigned() const
{
   return (unsigned long)value;
}

void**  AHandle::asAddress()
{
   return &value;
}
// Accessors

// Mutators

// Other operations
bool AHandle::isValid() const
{
   if(value == 0)
   {
      return false;
   }
   return true;
}

// protected
// Operations

// private
// Operations

// End of class definition of AHandle
