#ifndef _AHandle_hpp_
#define _AHandle_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@Askesis.nl

// Author : Joost Kraaijeveld
// Created: 14 Dec 1997 15:44:19
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers

// Forward declarations

class ALIBIMPEXP AHandle
{
   public:
      // Constructors
      AHandle( void* aValue = NULL);
      AHandle( const AHandle& aAHandle);

      // Destructor
      virtual ~AHandle();

      // Operators
      AHandle& operator=(const AHandle& aAHandle);
      bool operator==(const AHandle& aAHandle) const;
      bool operator<(const AHandle& aAHandle) const;
      operator void*() const;
      operator void*();
      operator void**() const;
      operator void**();

      // Accessors

      // Mutators

      // Other operations
      bool                                      isValid() const;
      // ALibObject functions
      virtual const char*                       asChar() const;
      virtual const char*                       asDebugChar() const;
      // AHandle functions
      unsigned long                             asUnsigned() const;
      void**                                    asAddress();

      // Attributes

   protected:
      // Attributes
      void*                                     value;

      // Operations

   private:
      // Friends

      // Operations

      // Attributes
}; // End of class declaration of AHandle

#endif //_AHandle_hpp_
