#ifndef _ALibString_hpp_
#define _ALibString_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 14 Jun 2000 10:00:08
// Purpose: Stand alone functions to get more out of the standard string class. Also
//          the include file for the standard string.

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers
#include <stdio.h>

// Operating system toolkit headers

// STL headers
#include <string>

// Other class headers

// Forward declarations

void stripLeadingSpaces(string& aString);
void stripTrainingSpaces(  string& aString);
void stringLeadingAndTrailingSpaces(string& aString);

string integerToString( unsigned long anInt);
string integerToString( long anInt);

// These conversion function throw an exception if aString cannot be converted
// This is done because than they can be used in automatic conversion functions.
// Wrong conversions must be debugged during development, not during releases
unsigned long stringToUnsignedLong(string& aString);
long stringToLong(string& aString);

// These functions should be replaced by a parser class some day as they are tied to the ATextProfile class
// If token occurs more than 1 time in the stringToSplit the string is split at the first occurrence.
void splitString(const string& aStringToSplit, string& aFirstString, const char aFirstToken, string& aSecondString);
void splitString(const string& aStringToSplit, string& aFirstString, const char aFirstToken, string& aSecondString, const char aSecondToken, string& aThirdString);

string bracketize(const string& aSectionName);
string bracketize(const char* aSectionName);


#endif // _ALibString_hpp_
