#include "AMutexObject.hpp"
#include "ATrace.hpp"

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 20:57:58

// public
// Constructors
AMutexObject::AMutexObject()
{
   // Development tracing
   AFUNCTRACE_DEVELOP();

   if (APlatform::isWin32S())
   {
      ATRACE_DEVELOP("Win32s: IPrivateResource() does not create semaphore");
      return;
   }
   semaphoreHandle = (AHandle)CreateMutex( 0, false, 0 );
   if(!semaphoreHandle.isValid())
   {
      ALibBaseException exception("CreateMutex");
      ATHROW(exception);
   }
}

// Destructor
AMutexObject::~AMutexObject()
{
   if (semaphoreHandle.isValid())
   {
      if (APlatform::isWin32S())
      {
         ATRACE_DEVELOP("Win32s: ~IPrivateResource() does not close semaphore");
      }else
      {
         if ( !CloseHandle( semaphoreHandle ) )
         {
            ALibBaseException exception("CloseHandle");
            ATHROW(exception);
         }
      }
   }
   semaphoreHandle = (AHandle)0;
}

// Operators

// Accessors

// Mutators

// Other operations

// protected
// Operations

// private
// Operations
AMutexObject::AMutexObject( const AMutexObject& aAMutexObject)
{
}

AMutexObject& AMutexObject::operator=(const AMutexObject& aAMutexObject)
{
   return *this;
}
// End of class definition of AMutexObject
