#include "APlatform.hpp"

/* static */ APlatform APlatform::platform;
/* static */ bool APlatform::win32  = false;
/* static */ bool APlatform::winNT  = false;
/* static */ bool APlatform::win32s = false;
/* static */ bool APlatform::win95  = false;
/* static */ bool APlatform::linux  = false;

APlatform::~APlatform()
{
   // Development tracing
//   AFUNCTRACE_DEVELOP();
}

/* static */ bool APlatform::isWin32()
{
   return APlatform::win32;
}

/* static */ bool APlatform::isWinNT()
{
   return APlatform::winNT;
}

/* static */ bool APlatform::isWin32S()
{
   return APlatform::win32s;
}

/* static */ bool APlatform::isWin95()
{
   return APlatform::win95;
}

/* static */ bool APlatform::isLinux()
{
   return APlatform::linux;
}

APlatform::APlatform()
{
   // Development tracing
//   AFUNCTRACE_DEVELOP();

#ifdef __ALIBWINDOWS__

   // The GetVersionEx function obtains extended information about the version of the
   // operating system that is currently running.
   // If the function succeeds, the return value is TRUE.
   // If the function fails, the return value is FALSE.
   // The function fails if the value of the dwOSVersionInfoSize member of the passed OSVERSIONINFO
   // structure is too small. A value that is too small indicates that the data structure is not large
   // enough to contain the current version information.
   OSVERSIONINFO versionInformation;
   versionInformation.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
   GetVersionEx(&versionInformation);  // points to version information structure

   switch(versionInformation.dwPlatformId)
   {
      case VER_PLATFORM_WIN32s:              // Win32s on Windows 3.1
      {
         APlatform::win32s = true;
         break;
      }
      case VER_PLATFORM_WIN32_WINDOWS:       //Win32 on Windows 95
      {
         APlatform::win95 = true;
         APlatform::win32 = true;
         break;
      }
      case VER_PLATFORM_WIN32_NT:            //Windows NT
      {
         APlatform::winNT = true;
         APlatform::win32 = true;
         break;
      }
   }

#endif // __ALIBWINDOWS__

#ifdef __ALIBLINUX__

   #error APlatform:Aplatform() This function is not correctly implemented and should not be called
   APlatform::linux = true;

#endif // __ALIBLINUX__
}
