#include "ASynchronizationObject.hpp"

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@Askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 April 2000 08:21:00

// public
// Constructors
ASynchronizationObject::ASynchronizationObject()
   :  semaphoreHandle(0),
      referenceCounter(0),
      synchronizationObjectLock(0)
{
}

// Destructor
ASynchronizationObject::~ASynchronizationObject()
{
   // What should we do with the handle??

   if(synchronizationObjectLock)
   {
      delete synchronizationObjectLock;
      synchronizationObjectLock = 0;
   }
   referenceCounter = 0;
}

// Operators

// Accessors
AHandle& ASynchronizationObject::getHandle()
{
   return semaphoreHandle;
}

// Mutators

// Operations
void ASynchronizationObject::lock( long aTimeOut)
{
   if(synchronizationObjectLock==0)
   {
      synchronizationObjectLock = new ASynchronizationObjectLock(*this,aTimeOut);
   }else
   {
      synchronizationObjectLock->lock(aTimeOut);
   }
}

void ASynchronizationObject::unlock()
{
   if(synchronizationObjectLock!=0)
   {
      synchronizationObjectLock->unlock();
   }
}

// protected
// Operations

// private
// Operations
ASynchronizationObject::ASynchronizationObject( const ASynchronizationObject& aASynchronizationObject)
{
}

ASynchronizationObject& ASynchronizationObject::operator=(const ASynchronizationObject& aASynchronizationObject)
{
   return *this;
}
