#ifndef _ASynchronizationObjectLock_hpp_
#define _ASynchronizationObjectLock_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created: 18 Jan 1998 20:17:44
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers
#ifdef __ALIBWINDOWS__
#include <windows.h>
#endif // __ALIBWINDOWS__

// STL headers

// Other class headers

// Forward declarations
class ASynchronizationObject;

class ALIBIMPEXP ASynchronizationObjectLock
{
   public:
      // Constructors
      ASynchronizationObjectLock(ASynchronizationObject& aASynchronizationObject, long aTimeOut = -1);

      // Destructor
      virtual ~ASynchronizationObjectLock();

      // Operators

      // Accessors

      // Mutators

      // Operations

      // Attributes

   protected:
      // Attributes

      // Operations
      virtual void                              lock(long aTimeOut = -1);
      virtual void                              unlock();

   private:
      // Friends
      friend class ASynchronizationObject;

      // Operations
      ASynchronizationObjectLock( const ASynchronizationObjectLock& aASynchronizationObjectLock);
      ASynchronizationObjectLock& operator=(const ASynchronizationObjectLock& aASynchronizationObjectLock);

      // Attributes
      ASynchronizationObject*                   synchronizationObject;

}; // End of class declaration of ASynchronizationObject

#endif // _ASynchronizationObjectLock_hpp_