#ifndef _AThreadFunction_hpp_
#define _AThreadFunction_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created:
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers
#include "AReferenceCountedObject.hpp"
#include "ATrace.hpp"

// Forward declarations

class ALIBIMPEXP AThreadFunction : public AReferenceCountedObject
{
   public:
      // Constructors
      AThreadFunction(){AFUNCTRACE_DEVELOP();}

      // Destructor
      virtual ~AThreadFunction(){AFUNCTRACE_DEVELOP();}

      // Operators

      // Accessors

      // Mutators

      // Other operations
      virtual void                              run() = 0;

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations

      // Attributes
}; // End of class declaration of AThreadFuntion


template < class T >
class ALIBIMPEXP AThreadMemberFunction : public AThreadFunction
{
   public:
      // Constructors
      AThreadMemberFunction(  T&obj, void (T::*mem)());

      // Destructor
      virtual ~AThreadMemberFunction();

      // Operators

      // Accessors

      // Mutators

      // Other operations
      virtual void                              run();

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Friends

      // Operations

      // Attributes
      T& object;
      void (T::*member)();
}; // AThreadMemberFunction

// I don't know how to get the compiler use the cpp file with templates...
// Constructors
template < class T >
AThreadMemberFunction<T>::AThreadMemberFunction(T &obj, void (T::*mem)())
   :  object(obj),
      member(mem)
{
   // Development tracing
   AFUNCTRACE_DEVELOP();
}

// Destructor
template < class T >
AThreadMemberFunction<T>::~AThreadMemberFunction()
{
   // Development tracing
   AFUNCTRACE_DEVELOP();
}

// Other operations
template < class T >
void AThreadMemberFunction<T>::run()
{
   // Development tracing
   AFUNCTRACE_DEVELOP();
   (object.*member)();
}

#endif