#ifndef _AThreadHandle_hpp_
#define _AThreadHandle_hpp_

// Copyright (c) 1997-2000 Askesis B.V. See licence.txt for details.
// For information, bug reports and additions send e-mail to ALib@askesis.nl

// Author : Joost Kraaijeveld
// Created:
// Purpose:

// Configuration file
#include "ALibBase.h"

// Standard C/C++ library headers

// Operating system toolkit headers

// STL headers

// Other class headers

// Forward declarations
class ALIBIMPEXP AThreadId
{
   public:
      // Constructors
      AThreadId() : threadId(0){}
      AThreadId(const AThreadId& aAThreadId ) : threadId(aAThreadId.threadId){}
      AThreadId(unsigned long aThreadId) : threadId(aThreadId){}

      // Destructors
      ~AThreadId(){}

      // Operators
      AThreadId& operator=(const AThreadId& aAThreadId ){threadId = aAThreadId.threadId;return *this;}
      bool operator==(const AThreadId& aAThreadId) const
      {
         if(threadId == 0 && aAThreadId.threadId == 0) return true;

         if(threadId != 0 && aAThreadId.threadId != 0)
         {
            return (threadId == aAThreadId.threadId);
         }else
         {  // if one of the handle value is 0
            return false;
         }
      }
      bool operator!=(const AThreadId& aAThreadId) const {return !(*this==aAThreadId);}
      operator unsigned long  () const {return threadId;}
      unsigned long* operator& () {return &threadId;} // Is this save??

      // Accessors

      // Mutators

      // Other operations
      bool isValid() const {if(threadId==0) return false;return true;}
      unsigned long asUnsigned() const {return threadId;}

      // Attributes

   protected:
      // Attributes

      // Operations

   private:
      // Attributes
      unsigned long                             threadId;

      // Operations
};

#ifdef __ALIBWINDOWS__
class ALIBIMPEXP AThreadHandle
{
   public:
      // Constructors
      AThreadHandle(void* aThreadHandle = 0) : threadHandle(aThreadHandle){}
      AThreadHandle(const AThreadHandle& aAThreadHandle) : threadHandle(aAThreadHandle.threadHandle){}

      // Destructor

      // Operators
      AThreadHandle& operator=(const AThreadHandle& aAThreadHandle)
      {
         threadHandle = aAThreadHandle.threadHandle;
         return *this;
      }
      bool operator==(const AThreadHandle& aAThreadHandle) const
      {
         return threadHandle == aAThreadHandle.threadHandle;
      }
      bool operator<(const AThreadHandle& aAThreadHandle) const
      {
         return threadHandle < aAThreadHandle.threadHandle;
      }

      operator void*() const {return threadHandle;}
      void* const* operator&() const {return &threadHandle;} // Is this save??

      // Accessors

      // Mutators

      // Other operations
      bool isValid() const {if(threadHandle==0) return false;return true;}
      unsigned long asUnsigned() const {return ((unsigned long)this->threadHandle);}

      // Attributes
      static const AThreadHandle                nullHandle;

   protected:
      // Attributes

      // Operations

   private:
      // Attributes
      void*                                     threadHandle;

      // Operations
};
#else
typedef AThreadId AThreadHandle;
#endif // __ALIBWINDOWS__

#endif
